diff --git a/sys/dev/virtual/vmware/shared/x86cpuid.h b/sys/dev/virtual/vmware/shared/x86cpuid.h
index 6f534e8..2658f84 100644
--- a/sys/dev/virtual/vmware/shared/x86cpuid.h
+++ b/sys/dev/virtual/vmware/shared/x86cpuid.h
@@ -665,41 +699,33 @@ FIELDDEFA( 81E,ECX, AMD,     8,  3, NODES_PER_PKG,       NA,  FALSE, AMD_NODES_P
  * CPUID_<vendor>_ID<level><reg>_<name>_SHIFT   == offset of field
  *
  * e.g. - CPUID_FEATURE_COMMON_ID1EDX_FPU     = 0x1
- *      - CPUID_COMMON_ID88EAX_VIRTBITS_MASK  = 0xff00
- *      - CPUID_COMMON_ID88EAX_VIRTBITS_SHIFT = 8
+ *      - CPUID_COMMON_ID88EAX_VIRT_BITS_MASK  = 0xff00
+ *      - CPUID_COMMON_ID88EAX_VIRT_BITS_SHIFT = 8
  *
  * Note: The FEATURE/MASK definitions must use some gymnastics to get
  * around a warning when shifting left by 32.
  */
 #define VMW_BIT_MASK(shift)  (((1 << (shift - 1)) << 1) - 1)
 
-#define FIELDDEF(lvl, reg, vend, bitpos, size, name, s, c3)             \
-   CPUID_##vend##_ID##lvl##reg##_##name##_SHIFT = bitpos,               \
-   CPUID_##vend##_ID##lvl##reg##_##name##_MASK  =                       \
-                      VMW_BIT_MASK(size) << bitpos,                     \
-   CPUID_FEATURE_##vend##_ID##lvl##reg##_##name =                       \
-                      CPUID_##vend##_ID##lvl##reg##_##name##_MASK,
+#define FIELD(lvl, ecxIn, reg, bitpos, size, name, s, c3)                    \
+   CPUID_ID##lvl##reg##_##name##_SHIFT = bitpos,                             \
+   CPUID_ID##lvl##reg##_##name##_MASK  = VMW_BIT_MASK(size) << bitpos,       \
+   CPUID_FEATURE_ID##lvl##reg##_##name = CPUID_ID##lvl##reg##_##name##_MASK, \
+   CPUID_INTERNAL_SHIFT_##name         = bitpos,                             \
+   CPUID_INTERNAL_MASK_##name          = VMW_BIT_MASK(size) << bitpos,       \
+   CPUID_INTERNAL_REG_##name           = CPUID_REG_##reg,                    \
+   CPUID_INTERNAL_EAXIN_##name         = CPUID_LEVEL_VAL_##lvl,              \
+   CPUID_INTERNAL_ECXIN_##name         = ecxIn,
 
-/* Before simplifying this take a look at bug 293638... */
-#define FIELDDEFA(lvl, reg, vend, bitpos, size, name, s, c3, f)         \
-   CPUID_##vend##_ID##lvl##reg##_##name##_SHIFT = bitpos,               \
-   CPUID_##vend##_ID##lvl##reg##_##name##_MASK  =                       \
-                      VMW_BIT_MASK(size) << bitpos,                     \
-   CPUID_FEATURE_##vend##_ID##lvl##reg##_##name =                       \
-                      CPUID_##vend##_ID##lvl##reg##_##name##_MASK,
-
-#define FLAGDEFA FIELDDEFA
-#define FLAGDEF FIELDDEF
+#define FLAG FIELD
 
 enum {
    /* Define data for every CPUID field we have */
    CPUID_FIELD_DATA
 };
 #undef VMW_BIT_MASK
-#undef FIELDDEF
-#undef FLAGDEF
-#undef FIELDDEFA
-#undef FLAGDEFA
+#undef FIELD
+#undef FLAG
 
 /* Level D subleaf 1 eax XSAVEOPT */
 #define CPUID_COMMON_IDDsub1EAX_XSAVEOPT 1
@@ -747,59 +773,136 @@ enum {
     NULL)
 
 /*
- * Macro to define GET and SET functions for various common CPUID
- * fields.  To create function for a new field, simply name it (CPUID_
- * and CPUID_SET_ are automatically prepended), and list the field
- * name that it needs to use.
+ * CPUID_MASK --
+ * CPUID_SHIFT --
+ * CPUID_ISSET --
+ * CPUID_GET --
+ * CPUID_SET --
+ * CPUID_CLEAR --
+ * CPUID_SETTO --
+ *
+ * Accessor macros for all CPUID consts/fields/flags.  Level and reg are not
+ * required, but are used to force compile-time asserts which help verify that
+ * the flag is being used on the right CPUID input and result register.
+ *
+ * Note: ASSERT_ON_COMPILE is duplicated rather than factored into its own
+ * macro, because token concatenation does not work as expected if an input is
+ * #defined (e.g. APIC) when macros are nested.  Also, compound statements
+ * within parenthes is a GCC extension, so we must use runtime asserts with
+ * other compilers.
+ */
+
+#if defined(__GNUC__) && !defined(__clang__)
+
+#define CPUID_MASK(eaxIn, reg, flag)                                    \
+   ({                                                                   \
+      ASSERT_ON_COMPILE(eaxIn == CPUID_INTERNAL_EAXIN_##flag &&         \
+              CPUID_REG_##reg == (CpuidReg)CPUID_INTERNAL_REG_##flag);  \
+      CPUID_INTERNAL_MASK_##flag;                                       \
+   })
+
+#define CPUID_SHIFT(eaxIn, reg, flag)                                   \
+   ({                                                                   \
+      ASSERT_ON_COMPILE(eaxIn == CPUID_INTERNAL_EAXIN_##flag &&         \
+              CPUID_REG_##reg == (CpuidReg)CPUID_INTERNAL_REG_##flag);  \
+      CPUID_INTERNAL_SHIFT_##flag;                                      \
+   })
+
+#define CPUID_ISSET(eaxIn, reg, flag, data)                             \
+   ({                                                                   \
+      ASSERT_ON_COMPILE(eaxIn == CPUID_INTERNAL_EAXIN_##flag &&         \
+              CPUID_REG_##reg == (CpuidReg)CPUID_INTERNAL_REG_##flag);  \
+      (((data) & CPUID_INTERNAL_MASK_##flag) != 0);                     \
+   })
+
+#define CPUID_GET(eaxIn, reg, field, data)                              \
+   ({                                                                   \
+      ASSERT_ON_COMPILE(eaxIn == CPUID_INTERNAL_EAXIN_##field &&        \
+              CPUID_REG_##reg == (CpuidReg)CPUID_INTERNAL_REG_##field); \
+      (((uint32)(data) & CPUID_INTERNAL_MASK_##field) >>                \
+       CPUID_INTERNAL_SHIFT_##field);                                   \
+   })
+
+#else
+
+/*
+ * CPUIDCheck --
+ *
+ * Return val after verifying parameters.
  */
 
-#define FIELD_FUNC(name, field)                                 \
-   static INLINE uint32 CPUID_##name(uint32 reg)                \
-   {                                                            \
-      return (reg & field##_MASK) >> field##_SHIFT;             \
-   }                                                            \
-   static INLINE void CPUID_SET_##name(uint32 *reg, uint32 val) \
-   {                                                            \
-      *reg = (*reg & ~field##_MASK) | (val << field##_SHIFT);   \
-   }
+static INLINE uint32
+CPUIDCheck(uint32 eaxIn, uint32 eaxInCheck,
+           CpuidReg reg, CpuidReg regCheck, uint32 val)
+{
+   ASSERT(eaxIn == eaxInCheck && reg == regCheck);
+   return val;
+}
 
-FIELD_FUNC(STEPPING,         CPUID_COMMON_ID1EAX_STEPPING)
-FIELD_FUNC(MODEL,            CPUID_COMMON_ID1EAX_MODEL)
-FIELD_FUNC(FAMILY,           CPUID_COMMON_ID1EAX_FAMILY)
-FIELD_FUNC(TYPE,             CPUID_COMMON_ID1EAX_TYPE)
-FIELD_FUNC(EXTENDED_MODEL,   CPUID_COMMON_ID1EAX_EXTMODEL)
-FIELD_FUNC(EXTENDED_FAMILY,  CPUID_COMMON_ID1EAX_EXTFAMILY)
-FIELD_FUNC(LCPU_COUNT,       CPUID_COMMON_ID1EBX_LCPU_COUNT)
-FIELD_FUNC(APICID,           CPUID_COMMON_ID1EBX_APICID)
-FIELD_FUNC(PA_BITS,          CPUID_COMMON_ID88EAX_PHYSBITS)
-FIELD_FUNC(VIRT_BITS,        CPUID_COMMON_ID88EAX_VIRTBITS)
-FIELD_FUNC(SVM_REVISION,     CPUID_AMD_ID8AEAX_SVM_REVISION)
-FIELD_FUNC(SVM_N_ASIDS,      CPUID_AMD_ID8AEBX_SVM_N_ASIDS)
-FIELD_FUNC(CACHE_TYPE,       CPUID_INTEL_ID4EAX_CACHE_TYPE)
-FIELD_FUNC(INTEL_CORE_COUNT, CPUID_INTEL_ID4EAX_CORE_COUNT)
-FIELD_FUNC(AMD_CORE_COUNT,   CPUID_AMD_ID88ECX_CORE_COUNT)
-FIELD_FUNC(AMD_APICID_COREID_SIZE, CPUID_AMD_ID88ECX_APICID_COREID_SIZE)
-FIELD_FUNC(AMD_EXTAPICSPC,   CPUID_AMD_ID81ECX_EXTAPICSPC)
-FIELD_FUNC(NUM_PMCS,         CPUID_INTEL_IDAEAX_NUM_PMCS)
-FIELD_FUNC(MWAIT_MIN_SIZE,   CPUID_COMMON_ID5EAX_MWAIT_MIN_SIZE)
-FIELD_FUNC(MWAIT_MAX_SIZE,   CPUID_COMMON_ID5EBX_MWAIT_MAX_SIZE)
-FIELD_FUNC(MWAIT_C0_SUBSTATE, CPUID_INTEL_ID5EDX_MWAIT_C0_SUBSTATE)
-FIELD_FUNC(MWAIT_C1_SUBSTATE, CPUID_INTEL_ID5EDX_MWAIT_C1_SUBSTATE)
-FIELD_FUNC(MWAIT_C2_SUBSTATE, CPUID_INTEL_ID5EDX_MWAIT_C2_SUBSTATE)
-FIELD_FUNC(MWAIT_C3_SUBSTATE, CPUID_INTEL_ID5EDX_MWAIT_C3_SUBSTATE)
-FIELD_FUNC(MWAIT_C4_SUBSTATE, CPUID_INTEL_ID5EDX_MWAIT_C4_SUBSTATE)
-FIELD_FUNC(TOPOLOGY_MASK_WIDTH,         CPUID_INTEL_IDBEAX_MASK_WIDTH)
-FIELD_FUNC(TOPOLOGY_CPUS_SHARING_LEVEL, CPUID_INTEL_IDBEBX_CPUS_SHARING_LEVEL)
-FIELD_FUNC(TOPOLOGY_LEVEL_NUMBER,       CPUID_INTEL_IDBECX_LEVEL_NUMBER)
-FIELD_FUNC(TOPOLOGY_LEVEL_TYPE,         CPUID_INTEL_IDBECX_LEVEL_TYPE)
-FIELD_FUNC(TOPOLOGY_X2APIC_ID,          CPUID_INTEL_IDBEDX_X2APIC_ID)
-FIELD_FUNC(AMD_CACHE_TYPE,      CPUID_AMD_ID81DEAX_CACHE_TYPE)
-FIELD_FUNC(AMD_CACHE_LEVEL,     CPUID_AMD_ID81DEAX_CACHE_LEVEL)
-FIELD_FUNC(AMD_CACHE_WAYS,      CPUID_AMD_ID81DEBX_CACHE_WAYS)
-FIELD_FUNC(AMD_NODES_PER_PKG,   CPUID_AMD_ID81EECX_NODES_PER_PKG)
-FIELD_FUNC(AMD_NUM_SHARING_CACHE, CPUID_AMD_ID81DEAX_NUM_SHARING_CACHE)
-FIELD_FUNC(AMD_CORES_PER_COMPUTE_UNIT, CPUID_AMD_ID81EEBX_CORES_PER_COMPUTE_UNIT)
-#undef FIELD_FUNC
+#define CPUID_MASK(eaxIn, reg, flag)                                    \
+   CPUIDCheck((uint32)eaxIn, CPUID_INTERNAL_EAXIN_##flag,               \
+              CPUID_REG_##reg, (CpuidReg)CPUID_INTERNAL_REG_##flag,     \
+              CPUID_INTERNAL_MASK_##flag)
+
+#define CPUID_SHIFT(eaxIn, reg, flag)                                   \
+   CPUIDCheck((uint32)eaxIn, CPUID_INTERNAL_EAXIN_##flag,               \
+              CPUID_REG_##reg, (CpuidReg)CPUID_INTERNAL_REG_##flag,     \
+              CPUID_INTERNAL_SHIFT_##flag)
+
+#define CPUID_ISSET(eaxIn, reg, flag, data)                             \
+   (CPUIDCheck((uint32)eaxIn, CPUID_INTERNAL_EAXIN_##flag,              \
+               CPUID_REG_##reg, (CpuidReg)CPUID_INTERNAL_REG_##flag,    \
+               CPUID_INTERNAL_MASK_##flag & (data)) != 0)
+
+#define CPUID_GET(eaxIn, reg, field, data)                              \
+   CPUIDCheck((uint32)eaxIn, CPUID_INTERNAL_EAXIN_##field,              \
+              CPUID_REG_##reg, (CpuidReg)CPUID_INTERNAL_REG_##field,    \
+              ((uint32)(data) & CPUID_INTERNAL_MASK_##field) >>         \
+              CPUID_INTERNAL_SHIFT_##field)
+
+#endif
+
+
+#define CPUID_SET(eaxIn, reg, flag, dataPtr)                            \
+   do {                                                                 \
+      ASSERT_ON_COMPILE(                                                \
+         (uint32)eaxIn   == (uint32)CPUID_INTERNAL_EAXIN_##flag &&      \
+         CPUID_REG_##reg == (CpuidReg)CPUID_INTERNAL_REG_##flag);       \
+      *(dataPtr) |= CPUID_INTERNAL_MASK_##flag;                         \
+   } while (0)
+
+#define CPUID_CLEAR(eaxIn, reg, flag, dataPtr)                          \
+   do {                                                                 \
+      ASSERT_ON_COMPILE(                                                \
+         (uint32)eaxIn   == (uint32)CPUID_INTERNAL_EAXIN_##flag &&      \
+         CPUID_REG_##reg == (CpuidReg)CPUID_INTERNAL_REG_##flag);       \
+      *(dataPtr) &= ~CPUID_INTERNAL_MASK_##flag;                        \
+   } while (0)
+
+#define CPUID_SETTO(eaxIn, reg, field, dataPtr, val)                    \
+   do {                                                                 \
+      uint32 _v = val;                                                  \
+      uint32 *_d = dataPtr;                                             \
+      ASSERT_ON_COMPILE(                                                \
+         (uint32)eaxIn   == (uint32)CPUID_INTERNAL_EAXIN_##field &&     \
+         CPUID_REG_##reg == (CpuidReg)CPUID_INTERNAL_REG_##field);      \
+      *_d = (*_d & ~CPUID_INTERNAL_MASK_##field) |                      \
+         (_v << CPUID_INTERNAL_SHIFT_##field);                          \
+      ASSERT(_v == (*_d & CPUID_INTERNAL_MASK_##field) >>               \
+             CPUID_INTERNAL_SHIFT_##field);                             \
+   } while (0)
+
+#define CPUID_SETTO_SAFE(eaxIn, reg, field, dataPtr, val)               \
+   do {                                                                 \
+      uint32 _v = val &                                                 \
+         (CPUID_INTERNAL_MASK_##field >> CPUID_INTERNAL_SHIFT_##field); \
+      uint32 *_d = dataPtr;                                             \
+      ASSERT_ON_COMPILE(                                                \
+         (uint32)eaxIn   == (uint32)CPUID_INTERNAL_EAXIN_##field &&     \
+         CPUID_REG_##reg == (CpuidReg)CPUID_INTERNAL_REG_##field);      \
+      *_d = (*_d & ~CPUID_INTERNAL_MASK_##field) |                      \
+         (_v << CPUID_INTERNAL_SHIFT_##field);                          \
+   } while (0)
 
 
 /*
@@ -807,54 +910,66 @@ FIELD_FUNC(AMD_CORES_PER_COMPUTE_UNIT, CPUID_AMD_ID81EEBX_CORES_PER_COMPUTE_UNIT
  * macros/functions for reading cpuid fields.
  */
 
-#define CPUID_FAMILY_EXTENDED 15
+#define CPUID_FAMILY_EXTENDED        15
 
 /* Effective Intel CPU Families */
-#define CPUID_FAMILY_486      4
-#define CPUID_FAMILY_P5       5
-#define CPUID_FAMILY_P6       6
-#define CPUID_FAMILY_P4       15
+#define CPUID_FAMILY_486              4
+#define CPUID_FAMILY_P5               5
+#define CPUID_FAMILY_P6               6
+#define CPUID_FAMILY_P4              15
 
 /* Effective AMD CPU Families */
-#define CPUID_FAMILY_5x86     4
-#define CPUID_FAMILY_K5       5
-#define CPUID_FAMILY_K6       5
-#define CPUID_FAMILY_K7       6
-#define CPUID_FAMILY_K8       15
-#define CPUID_FAMILY_K8L      16
-#define CPUID_FAMILY_K8MOBILE 17
-#define CPUID_FAMILY_LLANO    18
-#define CPUID_FAMILY_BOBCAT   20
-#define CPUID_FAMILY_BULLDOZER 21
+#define CPUID_FAMILY_5x86             4
+#define CPUID_FAMILY_K5               5 
+#define CPUID_FAMILY_K6               5
+#define CPUID_FAMILY_K7               6
+#define CPUID_FAMILY_K8              15
+#define CPUID_FAMILY_K8L             16
+#define CPUID_FAMILY_K8MOBILE        17
+#define CPUID_FAMILY_LLANO           18
+#define CPUID_FAMILY_BOBCAT          20
+#define CPUID_FAMILY_BULLDOZER       21
 
 /* Effective VIA CPU Families */
-#define CPUID_FAMILY_C7       6
+#define CPUID_FAMILY_C7               6
 
 /* Intel model information */
-#define CPUID_MODEL_PPRO       1
-#define CPUID_MODEL_PII_03     3
-#define CPUID_MODEL_PII_05     5
-#define CPUID_MODEL_CELERON_06 6
-#define CPUID_MODEL_PM_09      9
-#define CPUID_MODEL_PM_0D      13
-#define CPUID_MODEL_PM_0E      14    // Yonah / Sossaman
-#define CPUID_MODEL_CORE_0F    15    // Conroe / Merom
-#define CPUID_MODEL_CORE_17    0x17  // Penryn
-#define CPUID_MODEL_NEHALEM_1A 0x1a  // Nehalem / Gainestown
-#define CPUID_MODEL_ATOM_1C    0x1c  // Silverthorne / Diamondville
-#define CPUID_MODEL_CORE_1D    0x1d  // Dunnington
-#define CPUID_MODEL_NEHALEM_1E 0x1e  // Lynnfield
-#define CPUID_MODEL_NEHALEM_1F 0x1f  // Havendale
-#define CPUID_MODEL_NEHALEM_25 0x25  // Westmere / Clarkdale
-#define CPUID_MODEL_NEHALEM_2C 0x2c  // Westmere-EP
-#define CPUID_MODEL_NEHALEM_2E 0x2e  // Nehalem-EX
+#define CPUID_MODEL_PPRO              1
+#define CPUID_MODEL_PII_03            3
+#define CPUID_MODEL_PII_05            5
+#define CPUID_MODEL_CELERON_06        6
+#define CPUID_MODEL_PM_09             9
+#define CPUID_MODEL_PM_0D            13
+#define CPUID_MODEL_PM_0E            14  // Yonah / Sossaman
+#define CPUID_MODEL_CORE_0F          15  // Conroe / Merom
+#define CPUID_MODEL_CORE_17        0x17  // Penryn
+#define CPUID_MODEL_NEHALEM_1A     0x1a  // Nehalem / Gainestown
+#define CPUID_MODEL_ATOM_1C        0x1c  // Silverthorne / Diamondville
+#define CPUID_MODEL_CORE_1D        0x1d  // Dunnington
+#define CPUID_MODEL_NEHALEM_1E     0x1e  // Lynnfield
+#define CPUID_MODEL_NEHALEM_1F     0x1f  // Havendale
+#define CPUID_MODEL_NEHALEM_25     0x25  // Westmere / Clarkdale
+#define CPUID_MODEL_SANDYBRIDGE_2A 0x2a  // Sandybridge (desktop/mobile)
+#define CPUID_MODEL_SANDYBRIDGE_2D 0x2d  // Sandybridge-EP
+#define CPUID_MODEL_NEHALEM_2C     0x2c  // Westmere-EP
+#define CPUID_MODEL_NEHALEM_2E     0x2e  // Nehalem-EX
+#define CPUID_MODEL_NEHALEM_2F     0x2f  // Westmere-EX
+#define CPUID_MODEL_SANDYBRIDGE_3A 0x3a  // Ivy Bridge
+
 
 #define CPUID_MODEL_PIII_07    7
 #define CPUID_MODEL_PIII_08    8
 #define CPUID_MODEL_PIII_0A    10
 
 /* AMD model information */
-#define CPUID_MODEL_BARCELONA_02 0x02 // Barcelona (both Opteron & Phenom kind)
+#define CPUID_MODEL_BARCELONA_02      0x02 // Barcelona (Opteron & Phenom)
+#define CPUID_MODEL_SHANGHAI_04       0x04 // Shanghai RB
+#define CPUID_MODEL_SHANGHAI_05       0x05 // Shanghai BL
+#define CPUID_MODEL_SHANGHAI_06       0x06 // Shanghai DA
+#define CPUID_MODEL_ISTANBUL_MAGNY_08 0x08 // Istanbul (6 core) & Magny-cours (12) HY
+#define CPUID_MODEL_ISTANBUL_MAGNY_09 0x09 // HY - G34 package
+#define CPUID_MODEL_PHAROAH_HOUND_0A  0x0A // Pharoah Hound
+#define CPUID_MODEL_OPTERON_REVF_41   0x41 // family == CPUID_FAMILY_K8
 
 /* VIA model information */
 #define CPUID_MODEL_NANO       15     // Isaiah
@@ -880,7 +995,7 @@ CPUID_IsRawVendor(CPUIDRegs *id0, const char* vendor)
    // hard to get strcmp() in some environments, so do it in the raw
    return (id0->ebx == *(const uint32 *) (vendor + 0) &&
            id0->ecx == *(const uint32 *) (vendor + 4) &&
-           id0->edx == *(const uint32 *) (vendor + 8));
+           id0->edx == *(const uint32 *) (vendor + 8));   
 }
 
 static INLINE Bool
@@ -904,8 +1019,9 @@ CPUID_IsVendorVIA(CPUIDRegs *id0)
 static INLINE uint32
 CPUID_EFFECTIVE_FAMILY(uint32 v) /* %eax from CPUID with %eax=1. */
 {
-   return CPUID_FAMILY(v) +
-      (CPUID_FAMILY(v) == CPUID_FAMILY_EXTENDED ? CPUID_EXTENDED_FAMILY(v) : 0);
+   uint32 f = CPUID_GET(1, EAX, FAMILY, v);
+   return f != CPUID_FAMILY_EXTENDED ? f : f +
+      CPUID_GET(1, EAX, EXTENDED_FAMILY, v);
 }
 
 /* Normally only used when FAMILY==CPUID_FAMILY_EXTENDED, but Intel is
@@ -915,7 +1031,9 @@ CPUID_EFFECTIVE_FAMILY(uint32 v) /* %eax from CPUID with %eax=1. */
 static INLINE uint32
 CPUID_EFFECTIVE_MODEL(uint32 v) /* %eax from CPUID with %eax=1. */
 {
-   return CPUID_MODEL(v) + (CPUID_EXTENDED_MODEL(v) << 4);
+   uint32 m = CPUID_GET(1, EAX, MODEL, v);
+   uint32 em = CPUID_GET(1, EAX, EXTENDED_MODEL, v);
+   return m + (em << 4); 
 }
 
 /*
@@ -985,13 +1103,72 @@ CPUID_UARCH_IS_NEHALEM(uint32 v) // IN: %eax from CPUID with %eax=1.
    uint32 effectiveModel = CPUID_EFFECTIVE_MODEL(v);
 
    return CPUID_FAMILY_IS_P6(v) &&
-          (
-           effectiveModel == CPUID_MODEL_NEHALEM_1A ||
+          (effectiveModel == CPUID_MODEL_NEHALEM_1A ||
            effectiveModel == CPUID_MODEL_NEHALEM_1E ||
            effectiveModel == CPUID_MODEL_NEHALEM_1F ||
            effectiveModel == CPUID_MODEL_NEHALEM_25 ||
            effectiveModel == CPUID_MODEL_NEHALEM_2C ||
-           effectiveModel == CPUID_MODEL_NEHALEM_2E);
+           effectiveModel == CPUID_MODEL_NEHALEM_2E ||
+           effectiveModel == CPUID_MODEL_NEHALEM_2F);
+}
+
+
+static INLINE Bool
+CPUID_UARCH_IS_SANDYBRIDGE(uint32 v) // IN: %eax from CPUID with %eax=1.
+{
+   /* Assumes the CPU manufacturer is Intel. */
+   uint32 effectiveModel = CPUID_EFFECTIVE_MODEL(v);
+
+   return CPUID_FAMILY_IS_P6(v) &&
+          (effectiveModel == CPUID_MODEL_SANDYBRIDGE_2A ||
+           effectiveModel == CPUID_MODEL_SANDYBRIDGE_2D ||
+           effectiveModel == CPUID_MODEL_SANDYBRIDGE_3A);
+}
+
+
+
+static INLINE Bool
+CPUID_MODEL_IS_CENTERTON(uint32 v) // IN: %eax from CPUID with %eax=1.
+{
+   /* Assumes the CPU manufacturer is Intel. */
+   return CPUID_FAMILY_IS_P6(v) && 
+          CPUID_EFFECTIVE_MODEL(v) == CPUID_MODEL_ATOM_1C;
+}
+
+
+static INLINE Bool
+CPUID_MODEL_IS_WESTMERE(uint32 v) // IN: %eax from CPUID with %eax=1.
+{
+   /* Assumes the CPU manufacturer is Intel. */
+   uint32 effectiveModel = CPUID_EFFECTIVE_MODEL(v);
+
+   return CPUID_FAMILY_IS_P6(v) &&
+          (effectiveModel == CPUID_MODEL_NEHALEM_25 || // Clarkdale
+           effectiveModel == CPUID_MODEL_NEHALEM_2C || // Westmere-EP
+           effectiveModel == CPUID_MODEL_NEHALEM_2F);  // Westmere-EX
+}
+
+
+static INLINE Bool
+CPUID_MODEL_IS_SANDYBRIDGE(uint32 v) // IN: %eax from CPUID with %eax=1.
+{
+   /* Assumes the CPU manufacturer is Intel. */
+   uint32 effectiveModel = CPUID_EFFECTIVE_MODEL(v);
+
+   return CPUID_FAMILY_IS_P6(v) &&
+          (effectiveModel == CPUID_MODEL_SANDYBRIDGE_2A ||
+           effectiveModel == CPUID_MODEL_SANDYBRIDGE_2D);
+}
+
+
+static INLINE Bool
+CPUID_MODEL_IS_IVYBRIDGE(uint32 v) // IN: %eax from CPUID with %eax=1.
+{
+   /* Assumes the CPU manufacturer is Intel. */
+   uint32 effectiveModel = CPUID_EFFECTIVE_MODEL(v);
+
+   return CPUID_FAMILY_IS_P6(v) && (
+       effectiveModel == CPUID_MODEL_SANDYBRIDGE_3A);
 }
 
 
@@ -1017,7 +1194,7 @@ CPUID_FAMILY_IS_K8EXT(uint32 eax)
     * worth a separate function, for syntactic sugar.
     */
    return CPUID_FAMILY_IS_K8(eax) &&
-          CPUID_EXTENDED_MODEL(eax) != 0;
+          CPUID_GET(1, EAX, EXTENDED_MODEL, eax) != 0;
 }
 
 static INLINE Bool
@@ -1028,6 +1205,12 @@ CPUID_FAMILY_IS_K8L(uint32 eax)
 }
 
 static INLINE Bool
+CPUID_FAMILY_IS_LLANO(uint32 eax)
+{
+   return CPUID_EFFECTIVE_FAMILY(eax) == CPUID_FAMILY_LLANO;
+}
+
+static INLINE Bool
 CPUID_FAMILY_IS_K8MOBILE(uint32 eax)
 {
    /* Essentially a K8 (not K8L) part, but with mobile features. */
@@ -1057,6 +1240,7 @@ CPUID_FAMILY_IS_BULLDOZER(uint32 eax)
    return CPUID_EFFECTIVE_FAMILY(eax) == CPUID_FAMILY_BULLDOZER;
 }
 
+
 /*
  * AMD Barcelona (of either Opteron or Phenom kind).
  */
@@ -1069,21 +1253,70 @@ CPUID_MODEL_IS_BARCELONA(uint32 v) // IN: %eax from CPUID with %eax=1.
 }
 
 
+static INLINE Bool
+CPUID_MODEL_IS_SHANGHAI(uint32 v) // IN: %eax from CPUID with %eax=1.
+{
+   /* Assumes the CPU manufacturer is AMD. */
+   return CPUID_EFFECTIVE_FAMILY(v) == CPUID_FAMILY_K8L &&
+          (CPUID_MODEL_SHANGHAI_04  <= CPUID_EFFECTIVE_MODEL(v) && 
+           CPUID_EFFECTIVE_MODEL(v) <= CPUID_MODEL_SHANGHAI_06);
+}
+
+
+static INLINE Bool
+CPUID_MODEL_IS_ISTANBUL_MAGNY(uint32 v) // IN: %eax from CPUID with %eax=1.
+{
+   /* Assumes the CPU manufacturer is AMD. */
+   return CPUID_EFFECTIVE_FAMILY(v) == CPUID_FAMILY_K8L &&
+          (CPUID_MODEL_ISTANBUL_MAGNY_08 <= CPUID_EFFECTIVE_MODEL(v) &&
+           CPUID_EFFECTIVE_MODEL(v)      <= CPUID_MODEL_ISTANBUL_MAGNY_09);
+}
+
+
+static INLINE Bool
+CPUID_MODEL_IS_PHAROAH_HOUND(uint32 v) // IN: %eax from CPUID with %eax=1.
+{
+   /* Assumes the CPU manufacturer is AMD. */
+   return CPUID_EFFECTIVE_FAMILY(v) == CPUID_FAMILY_K8L &&
+          CPUID_EFFECTIVE_MODEL(v)  == CPUID_MODEL_PHAROAH_HOUND_0A;
+}
+
+
+static INLINE Bool
+CPUID_MODEL_IS_BULLDOZER(uint32 eax)
+{
+   return CPUID_EFFECTIVE_FAMILY(eax) == CPUID_FAMILY_BULLDOZER;
+}
+
+
+
+
 #define CPUID_TYPE_PRIMARY     0
 #define CPUID_TYPE_OVERDRIVE   1
 #define CPUID_TYPE_SECONDARY   2
 
-#define CPUID_INTEL_ID4EAX_CACHE_TYPE_NULL      0
-#define CPUID_INTEL_ID4EAX_CACHE_TYPE_DATA      1
-#define CPUID_INTEL_ID4EAX_CACHE_TYPE_INST      2
-#define CPUID_INTEL_ID4EAX_CACHE_TYPE_UNIF      3
-
-#define CPUID_INTEL_ID4EAX_CACHE_SELF_INIT      0x00000100
-#define CPUID_INTEL_ID4EAX_CACHE_FULLY_ASSOC    0x00000200
+#define CPUID_INTEL_ID4EAX_LEAF4_CACHE_TYPE_NULL      0
+#define CPUID_INTEL_ID4EAX_LEAF4_CACHE_TYPE_DATA      1
+#define CPUID_INTEL_ID4EAX_LEAF4_CACHE_TYPE_INST      2
+#define CPUID_INTEL_ID4EAX_LEAF4_CACHE_TYPE_UNIF      3
+#define CPUID_LEAF4_CACHE_TYPE_NULL      0
+#define CPUID_LEAF4_CACHE_TYPE_DATA      1
+#define CPUID_LEAF4_CACHE_TYPE_INST      2
+#define CPUID_LEAF4_CACHE_TYPE_UNIF      3
+#define CPUID_LEAF4_CACHE_INDEXING_DIRECT  0
+#define CPUID_LEAF4_CACHE_INDEXING_COMPLEX 1
+
+#define CPUID_INTEL_ID4EAX_LEAF4_CACHE_SELF_INIT      0x00000100
+#define CPUID_INTEL_ID4EAX_LEAF4_CACHE_FULLY_ASSOC    0x00000200
+#define CPUID_LEAF4_CACHE_SELF_INIT      0x00000100
+#define CPUID_LEAF4_CACHE_FULLY_ASSOC    0x00000200
 
 #define CPUID_INTEL_IDBECX_LEVEL_TYPE_INVALID   0
 #define CPUID_INTEL_IDBECX_LEVEL_TYPE_SMT       1
 #define CPUID_INTEL_IDBECX_LEVEL_TYPE_CORE      2
+#define CPUID_TOPOLOGY_LEVEL_TYPE_INVALID   0
+#define CPUID_TOPOLOGY_LEVEL_TYPE_SMT       1
+#define CPUID_TOPOLOGY_LEVEL_TYPE_CORE      2
 
 
 /*
@@ -1128,7 +1361,7 @@ CPUID_RequiresFence(CpuidVendor vendor, // IN
 }
 
 
-/*
+/* 
  * The following low-level functions compute the number of
  * cores per cpu.  They should be used cautiously because
  * they do not necessarily work on all types of CPUs.
@@ -1140,7 +1373,7 @@ static INLINE uint32
 CPUID_IntelCoresPerPackage(uint32 v) /* %eax from CPUID with %eax=4 and %ecx=0. */
 {
    // Note: This is not guaranteed to work on older Intel CPUs.
-   return 1 + CPUID_INTEL_CORE_COUNT(v);
+   return 1 + CPUID_GET(4, EAX, LEAF4_CORE_COUNT, v);
 }
 
 
@@ -1148,7 +1381,7 @@ static INLINE uint32
 CPUID_AMDCoresPerPackage(uint32 v) /* %ecx from CPUID with %eax=0x80000008. */
 {
    // Note: This is not guaranteed to work on older AMD CPUs.
-   return 1 + CPUID_AMD_CORE_COUNT(v);
+   return 1 + CPUID_GET(0x80000008, ECX, LEAF88_CORE_COUNT, v);
 }
 
 
@@ -1161,5 +1394,85 @@ CPUID_IsHypervisorLevel(uint32 level)
    return (level & 0xffffff00) == 0x40000000;
 }
 
+/*
+ *----------------------------------------------------------------------
+ *
+ * CPUID_LevelUsesEcx --
+ *
+ *      Returns TRUE for leaves that support input ECX != 0 (subleaves).
+ *
+ *----------------------------------------------------------------------
+ */
+
+static INLINE Bool
+CPUID_LevelUsesEcx(uint32 level) {
+   return level == 4 || level == 7 || level == 0xb || level == 0xd ||
+          level == 0x8000001d;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * CPUID_IsValid*Subleaf --
+ *
+ *      Functions to determine the last subleaf for the level specified
+ *
+ *----------------------------------------------------------------------
+ */
+
+static INLINE Bool
+CPUID_IsValidBSubleaf(uint32 ebx)  // IN: %ebx = cpuid.b.sublevel.ebx
+{
+   return ebx != 0;
+}
+
+static INLINE Bool
+CPUID_IsValid4Subleaf(uint32 eax)  // IN: %eax = cpuid.4.sublevel.eax
+{
+   return eax != 0;
+}
+
+static INLINE Bool
+CPUID_IsValid7Subleaf(uint32 eax, uint32 subleaf)  // IN: %eax = cpuid.7.0.eax
+{
+   /*
+    * cpuid.7.0.eax is the max ecx (subleaf) index
+    */
+   return subleaf <= eax;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * CPUID_IsValidDSubleaf --
+ *
+ *    It is the caller's repsonsibility to determine if the processor
+ *    supports XSAVE and therefore has D sub-leaves.
+ *
+ *----------------------------------------------------------------------
+ */
+static INLINE Bool
+CPUID_IsValidDSubleaf(uint32 subleaf)  // IN: subleaf to check
+{
+   return subleaf <= 63;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * CPUID_SupportsMsrPlatformInfo --
+ *
+ *    Uses vendor and cpuid.1.0.eax to determine if the processor
+ *    supports MSR_PLATFORM_INFO.
+ *
+ *----------------------------------------------------------------------
+ */
+static INLINE Bool
+CPUID_SupportsMsrPlatformInfo(CpuidVendor vendor, uint32 version)
+{
+   return vendor == CPUID_VENDOR_INTEL &&
+          (CPUID_UARCH_IS_NEHALEM(version) ||
+           CPUID_UARCH_IS_SANDYBRIDGE(version));
+}
 
 #endif
diff --git a/sys/dev/virtual/vmware/shared/x86cpuid_asm.h b/sys/dev/virtual/vmware/shared/x86cpuid_asm.h
index 5aaedae..f49f11f 100644
--- a/sys/dev/virtual/vmware/shared/x86cpuid_asm.h
+++ b/sys/dev/virtual/vmware/shared/x86cpuid_asm.h
@@ -260,7 +260,7 @@ __GET_CPUID(int input, CPUIDRegs *regs)
 #ifdef VM_X86_64
 
 /*
- * No inline assembly in Win64. Implemented in bora/lib/user in
+ * No inline assembly in Win64. Implemented in bora/lib/misc in
  * cpuidMasm64.asm.
  */
 
@@ -404,7 +404,7 @@ __GET_EDX_FROM_CPUID(int input)
 #ifdef VM_X86_64
 
 /*
- * No inline assembly in Win64. Implemented in bora/lib/user in
+ * No inline assembly in Win64. Implemented in bora/lib/misc in
  * cpuidMasm64.asm.
  */
 
diff --git a/sys/gnu/dev/virtual/vmware/vmmemctl/Makefile b/sys/gnu/dev/virtual/vmware/vmmemctl/Makefile
index 3490bdf..369deaa 100644
--- a/sys/gnu/dev/virtual/vmware/vmmemctl/Makefile
+++ b/sys/gnu/dev/virtual/vmware/vmmemctl/Makefile
@@ -1,6 +1,6 @@
 KMOD=	vmmemctl
 
-SRCS=	os.c vmballoon.c
+SRCS=	os.c vmballoon.c backdoor_balloon.c kernelStubsBSD.c
 
 .if $(MACHINE_ARCH) == "x86_64"
 SRCS+=	backdoorGcc64.c
diff --git a/sys/gnu/dev/virtual/vmware/vmmemctl/backdoorGcc64.c b/sys/gnu/dev/virtual/vmware/vmmemctl/backdoorGcc64.c
index 4a7630c..93ce2c6 100644
--- a/sys/gnu/dev/virtual/vmware/vmmemctl/backdoorGcc64.c
+++ b/sys/gnu/dev/virtual/vmware/vmmemctl/backdoorGcc64.c
@@ -125,7 +125,7 @@ Backdoor_InOut(Backdoor_proto *myBp) // IN/OUT
 void
 BackdoorHbIn(Backdoor_proto_hb *myBp) // IN/OUT
 {
-   uint32 dummy;
+   uint64 dummy;
 
    __asm__ __volatile__(
         "pushq %%rbp"           "\n\t"
